Subject: Re: [RFC][net-next-2.6 PATCH 4/4] net: remove check for headroom in vlan_dev_create

From: John Fastabend <[email-masked]>
Date: Tue, 26 Oct 2010 15:05:44 -0700

On 10/25/2010 3:45 PM, Jesse Gross wrote:
> On Thu, Oct 21, 2010 at 3:10 PM, John Fastabend
> <[email-masked]> wrote:
>> It is possible for the headroom to be smaller then the
>> hard_header_len for a short period of time after toggling
>> the vlan offload setting.
>>
>> This is not a hard error and skb_cow_head is called in
>> __vlan_put_tag() to resolve this.
>>
>> Signed-off-by: John Fastabend <[email-masked]>
> 
> How is it possible that the hard_header_len changes on the vlan
> device?  It looks like the header length never gets changed after it
> is initialized.  There's no set_flags method in the vlan device to
> toggle whether it is using offloading or not, it just rides on top of
> the underlying device.

Your right and I think this is why my previous patch was broken. If we
can toggle the underlying offloads we should set the header length as
well. With the updated patch I just sent this should be true now.

Thanks,
John.

> On the other hand, I agree that this check isn't actually necessary.